___________________________________________________________
| C.A.L  --  Cavalry Asset Library
| Created by Elliot Mosher, 2023
| elliotmosher.com  |  YT: @ElliotMosher
|__________________________________________________________

C.A.L lets you easily save complex rigs, with all connections and animations, in a few clicks. Create multiple libraries that you can share with other people!


HOW TO INSTALL THIS SCRIPT:
In Cavalry, click on the Help Menu and select 'Show Scripts Folder', and place the Cavalry_Asset_Library.jsc into that folder. You will then see that script available in the Scripts menu in Cavalry. Select Cavalry_Asset_Library from that list and dock the panel wherever you like. Make sure to save your new layout by going to the Window menu and clicking on Save Workspace.


_____HOW TO USE C.A.L_____


_____Main Panel_________________________
C.A.L defaults to this panel on startup. To get back to the Main Panel, click on the left button in the lower right side of the window. It's the button that looks like a list.

ADDING SAVED ASSETS TO THE SCENE
Adding assets to your scene is simple -- You can select which library you want to use at the top, and double click on any thumbnail to load the asset into your scene. You can also single click to select an asset and click the 'Add to Scene' button if you prefer. By default, C.A.L will load the Asset on the root level, aka unparented even if you have a layer selected. If you wish to add an asset as a Child of whatever you have selected, simple hold Alt/option when you double click or click 'Add to Scene'.

EDITING A SAVED ASSET
When you select an asset in the thumbnail window, the Edit panel will automatically update with that assets name, and the current library. If you want to only change the name of your asset, simply type in the name you want it to be, and click the 'Confirm Edit' button. If you only want to change which library this asset is stored in, leave the name as it is, and select a different library from the dropdown menu inside the Edit Panel and then click the 'Confirm Edit' button.. If you want to change the name AND which library it is stored in, simply change both and then click the 'Confirm Edit' button.

DELETING AN ASSET
If you wish to delete an asset, select it in the thumbnail window, and click on the trashcan icon in the lower right of the panel. This will pop up a checkbox and a new button highlighted in red. To delete the asset, you must check the box and then click on the 'Permanently Delete Asset' button. THIS PERMANENTALY DELETES THE ASSET.

Creating Custom Thumbnails
C.A.L will automatically generate thumbnails of your Assets, but sometimes you might want a custom thumbnail for something. You can Right Click on a selected thumbnail and click on "Make thumbnail from Active Comp". This will create and assign a thumbnail that is whatever your current open comp is. Best practice for this is to use a square comp, and unless you specifically want a background color, setting the background to white with alpha 10 will keep it consistent with the automatically generated thumbnails. NOTE: Custom thumbnails aren't 'saved' within the actual library. This means that if you give someone else this library, they will have a default generated thumbnail for that item.


____Save Asset Panel______________________
To get to the Save Asset Panel, click on the middle button in the lower right side of the window. It is a square with a plus sign on it.

SAVING AN ASSET TO A LIBRARY
At the top you can select which Exisiting library you want this asset to save to. If you wish to create a NEW library, click the checkbox next to the text input that says 'New Library Name'.
Underneath that is where you will name this asset. Your asset must have a name, and it must be a unique name.

Anything you have selected will be saved when you press 'Save Selection'. C.A.L does it's best to include all children and connections, but there are a few cases where it might miss things i.e. if you have a Shape -> Duplicator1 -> Duplicator2 set up, the shape technically isn't connected to Duplicator2, so it wouldn't automatically be included. I'm hoping to make that more robust in future versions.

BEST PRACTICE
For now the best practice would be to put all relevant layers you want included in your asset into a folder, then select the folder to save.

THUMBNAIL FRAME
C.A.L will automatically generate thumbnails for you when you save an Asset to a library. It will also generate the thumbnail based on the frame the playhead is at when the Asset is saved. This is so that if you create something like a transition, or a physics sim, you can scroll to the frame that looks the best, and your thumbnail will be based on that frame. This frame number is saved in the Asset, so if you share this library with others, their generated thumbnail will be based on that same frame that you chose.

___Settings Panel__________________________
To get to the Settings Panel, click on the gear icon in the lower left of the window

Create Assets in a Group
If this is checked, any time you add an asset to the scene, it will be added into a Group folder that will be named whatever the Asset is named. With the current 'best practice' of grouping layers before saving, this is a bit redundant, but it provides more flexibility with how you want to work. (I personally have it off for now)

Backup Libraries and Set Frequency
C.A.L will automatically back up your libraries on a set amount of 'startups'. The default is 10, meaning every 10th time C.A.L is opened, it will duplicate your existing libraries into a library_backups folder inside the CAL_assets folder. You can set the frequency of backups as you wish. If you set the frequency to -1, it will never backup the libraries (not reccommended). The Backup Libraries Now button will backup all of your existing libraries and reset the frequency 'timer' to 0. 

Clean assets in Active Library
There are tons of new features that I will be adding to C.A.L over time, which means that the data schema will change over time. When you import a library, C.A.L will automatically scan your assets and add default values to anything that is missing (if the library was created in an older version). This button will do the same thing to whatever your active library is. This is most likely not super necessary, but is there incase anything gets wonky.

Import External Library
Here is where you can import C.A.L libraries that other people have made. On import, C.A.L will automatically generate thumbnails and set this new library as the Active Library

Reset Preferences to Default
Pretty much all settings get saved as they are adjusted. If for some reason something gets weird, you can always reset the preferences to the default. Currently there's no good way to 'auto refresh' the script panel, so if you do reset to default you should close the C.A.L panel and restart. 



********************************
Current Limitations
********************************

There are a few limitations that are being worked on, but worth mentioning so that you are aware of them, and aware that I am working on improving them.

THUMBNAILS
C.A.L will automatically generate thumbnails of your creations. Most of the time they look nice, but it generates the thumbnail based on the overall size of your selected rig. This means that if you have an invisible object that's way off to the side, your thumbnail might look small, or off-centered. Where possible 

DUPLICATOR CHAINS
As mentioned above, C.A.L does it's best to collect everything based on a single layer clicked. However, duplicators inside of duplicators can get lost. This is why the Best Practice is to group things before saving them. If you group your layers first and then save the Asset, nothing should be missed. 

CONTROL RIGS
Control Rigs, or 'joysticks' in Cavalry work by creating a new Keyframe Layer. Currently there's some bugs around automatically creating a new Keyframe Layer on import. You CAN save rigs that utilize Control Rigs, and they will import already connected to what you originally had them connected to, they just won't work. All you need to do is reconnect the Control Rig to what it's connected to and it should work. It seems like if you've already created a Control Rig, or if you import one Asset and reconnected the Control Rig, then Assets imported after that might just work as expected. This limitation is annoying and is high on my list to get fixed. 

